// exampleDlg.cpp : implementation file
//

#include "stdafx.h"
#include "example.h"
#include "exampleDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CExampleDlg dialog

CExampleDlg::CExampleDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CExampleDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CExampleDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CExampleDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CExampleDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CExampleDlg, CDialog)
	//{{AFX_MSG_MAP(CExampleDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_BN_CLICKED(IDC_BUTTON2, OnButton2)
	ON_BN_CLICKED(IDC_BUTTON3, OnButton3)
	ON_BN_CLICKED(IDC_BUTTON4, OnButton4)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CExampleDlg message handlers

BOOL CExampleDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CExampleDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

HCURSOR CExampleDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}
/////////////////////////////////////////////////////////////////////////////
BOOL CExampleDlg::LoadSplitMergeDll()
{
	m_hinstLib = LoadLibrary("pdfsplitmerge.dll");
	if( m_hinstLib == NULL ){ 
		return FALSE;
	}

	pMSplitBegin = (MSplitBegin *)GetProcAddress(m_hinstLib, "MSplitBegin");
	if( pMSplitBegin == NULL ){ 
		FreeSplitMergeDll(); 
		return FALSE;
	}
	pMSplit = (MSplit *)GetProcAddress(m_hinstLib, "MSplit");
	if( pMSplit == NULL ){ 
		FreeSplitMergeDll(); 
		return FALSE;
	}
	pMSplitEnd = (MSplitEnd *)GetProcAddress(m_hinstLib, "MSplitEnd");
	if( pMSplitEnd == NULL ){ 
		FreeSplitMergeDll(); 
		return FALSE;
	}
	pMMergeBegin = (MMergeBegin *)GetProcAddress(m_hinstLib, "MMergeBegin");
	if( pMMergeBegin == NULL ){ 
		FreeSplitMergeDll(); 
		return FALSE;
	}
	pMMergeSetFiles = (MMergeSetFiles *)GetProcAddress(m_hinstLib, "MMergeSetFiles");
	if( pMMergeSetFiles == NULL ){ 
		FreeSplitMergeDll(); 
		return FALSE;
	}
	pMMerge = (MMerge *)GetProcAddress(m_hinstLib, "MMerge");
	if( pMMerge == NULL ){ 
		FreeSplitMergeDll(); 
		return FALSE;
	}
	pMMergeEnd = (MMergeEnd *)GetProcAddress(m_hinstLib, "MMergeEnd");
	if( pMMergeEnd == NULL ){ 
		FreeSplitMergeDll(); 
		return FALSE;
	}
	pMWatermark = (MWatermark *)GetProcAddress(m_hinstLib, "MWatermark");
	if( pMWatermark == NULL ){ 
		FreeSplitMergeDll(); 
		return FALSE;
	}

	return TRUE;
}
/////////////////////////////////////////////////////////////////////////////
BOOL CExampleDlg::FreeSplitMergeDll()
{
	if( m_hinstLib ){
        FreeLibrary(m_hinstLib);
	}
	return TRUE;
}
/////////////////////////////////////////////////////////////////////////////
void CExampleDlg::OnButton1() 
{
	if( LoadSplitMergeDll() == FALSE ){
		MessageBox("Load pdfsplitmerge.dll failed!");
		return;
	}
	
	long id = pMSplitBegin("test.pdf",NULL);
	if(id==-1){
		MessageBox("PDF file unexist or damaged!");
		FreeSplitMergeDll();
		return;
	}
	if(id==-2){
		MessageBox("PDF file is restricted!");
		FreeSplitMergeDll();
		return;
	}

	long mode = 1;
	char outPath[256];
	strcpy(outPath,"split");
	pMSplit(id,outPath,mode,NULL);

	pMSplitEnd(id);

	FreeSplitMergeDll();
	MessageBox("Split finished!");
}
/////////////////////////////////////////////////////////////////////////////
void CExampleDlg::OnButton2() 
{
	if( LoadSplitMergeDll() == FALSE ){
		MessageBox("Load pdfsplitmerge.dll failed!");
		return;
	}
	
	long id = pMSplitBegin("test.pdf",NULL);
	if(id==-1){
		MessageBox("PDF file unexist or damaged!");
		FreeSplitMergeDll();
		return;
	}
	if(id==-2){
		MessageBox("PDF file is restricted!");
		FreeSplitMergeDll();
		return;
	}
	
	long mode = 2;
	char outFile[256];
	strcpy(outFile,"Deleted.pdf");
	pMSplit(id,outFile,mode,"3-8");

	pMSplitEnd(id);

	FreeSplitMergeDll();
	MessageBox("Delete finished!");	
}
/////////////////////////////////////////////////////////////////////////////
void CExampleDlg::OnButton3() 
{
	if( LoadSplitMergeDll() == FALSE ){
		MessageBox("Load pdfsplitmerge.dll failed!");
		return;
	}
	
	long id = pMSplitBegin("test.pdf",NULL);
	if(id==-1){
		MessageBox("PDF file unexist or damaged!");
		FreeSplitMergeDll();
		return;
	}
	if(id==-2){
		MessageBox("PDF file is restricted!");
		FreeSplitMergeDll();
		return;
	}

	long mode = 3;
	char outFile[256];
	strcpy(outFile,"Extract.pdf");
	pMSplit(id,outFile,mode,"3-8,9,15");

	pMSplitEnd(id);

	FreeSplitMergeDll();
	MessageBox("Extract finished!");	
}
/////////////////////////////////////////////////////////////////////////////
void CExampleDlg::OnButton4() 
{
	if( LoadSplitMergeDll() == FALSE ){
		MessageBox("Load pdfsplitmerge.dll failed!");
		return;
	}
	
	long id = pMMergeBegin();
	if(id<=0){
		MessageBox("Creat PDF file failed!");
		FreeSplitMergeDll();
		return;
	}

	pMMergeSetFiles(id,"test.pdf",NULL,"1-3");
	pMMergeSetFiles(id,"test.pdf",NULL,"5");	
	pMMergeSetFiles(id,"test.pdf",NULL,"7-9");

	long fsize=16;
	long fcolor=255;//red
	long position=2;//Top-Center
	long angle=0;
	long xoff=0;
	long yoff=0;
	long asbackground=0;
	//Stamping
	pMWatermark(id,"Merge into one pdf file",fsize,fcolor,position,angle,xoff,yoff,asbackground);

	char outFile[256];
	strcpy(outFile,"Merged.pdf");
	pMMerge(id,outFile);
	
	pMMergeEnd(id);

	FreeSplitMergeDll();
	MessageBox("Merge finished!");		
}
